{ Editor holubu pro Tipes MC2100 ...
  Omluvte snizenou kvalitu zdrojaku, je to cely poslepovany narychlo
  Autor: Honza Matuska, honzamat@atlas.cz }

uses Dos,Crt;

type hol=record cislo:string[20];
                cip:string[40];
                end;
var
  n,holubu,hlavicek:integer;
  head: array[1..35] of string;
  data: array[1..600] of hol;
  soubor:string;
  ch:char;
   k:char;


{ *** kresleni ramecku *** }
procedure Frame(x1,y1,x2,y2,clr,after:integer);
 var n:integer;
 begin
  TextColor(clr);
  for n:=(x1+1) to (x2-1) do begin gotoxy(n,y1); writeln('');
                                   gotoxy(n,y2); writeln(''); end;
  for n:=(y1+1) to (y2-1) do begin gotoxy(x1,n); writeln('');
                                   gotoxy(x2,n); writeln(''); end;
  gotoxy(x2,y1);writeln(''); gotoxy(x1,y2);writeln('');
  gotoxy(x1,y1);writeln(''); gotoxy(x2,y2);writeln('');
  TextColor(after);
 end;


{ *** nahrani dat ze souboru do pole *** }
function LoadFile(ext:string):string;
var
  F: Text;
  Ch: String;
  DirInfo: SearchRec;
  halte:integer;
begin
 LoadFile:='';
 FindFirst('*.'+ext,Archive, DirInfo);
 if DosError = 0 then begin
  soubor:=dirinfo.name;
  Assign(F, dirinfo.name); Reset(F);
  hlavicek:=0;
  for n:=1 to 3 do begin
           readln(F,Ch);
           hlavicek:=hlavicek+1;
           head[hlavicek]:=Ch;
           end;
  halte:=0;
  while (Ch<>'0000000000000000000000000000') do begin
        halte:=halte+1;
        if halte=2000 then halt;
        readln(F,Ch);
        end;
  holubu:=0;
  while not Eof(F) do
   begin
     holubu:=holubu+1;
     Readln(F, Ch);
     data[holubu].cislo:=copy(Ch,1,20);
     data[holubu].cip:=copy(Ch,21,52);
   end;
  Close(F);
 end else LoadFile:='noexist';
end;


{ *** zapsani pole do souboru *** }
procedure WriteIt(soub:string);
var
  F: Text;
begin
  Assign(F, soub); Rewrite(F);
  for n:=1 to 3 do writeln(F,head[n]);
  for n:=1 to 31 do writeln(F,'00000000000000000000000000000000');
  writeln(F,'0000000000000000000000000000');
  if holubu>0 then for n:=1 to holubu do writeln(F,data[n].cislo+data[n].cip);
  Close(F);
end;


{ *** dump screen.inc na obrazovku *** }
procedure DumpScreen;
var F:text;
    zn:char;
begin
Textbackground(7);
TextColor(1);
clrscr;
Assign(F, 'screen.inc');
Reset(F);
while not Eof(F) do
begin
  Read(F, Ch);
  Write(Ch);
end;

end;


{ *** prekopana fc read *** }
function InsText(delka,x,y:integer):string;
 var r,pocet:integer;out:string;
     pole:array[0..20] of string;
 begin
 pocet:=0; out:=''; gotoxy(x+1,y);
 repeat
  ch:=readkey;
  if ord(ch)=27 then begin InsText:=''; exit; end;
  if ((ord(ch)=8) AND (pocet<>0)) then pocet:=pocet-1;
  if pocet>delka then pocet:=delka;
  if ((ord(ch)>=32) AND (ord(ch)<=126) AND (pocet<delka)) then begin
   pocet:=pocet+1; pole[pocet]:=ch;
  end;
  for r:=1 to delka do begin gotoxy(x+r,y); write(' '); end;
  for r:=1 to pocet do begin gotoxy(x+r,y); write(pole[r]); end;
  if pocet=0 then gotoxy(x+1,y);
 until ord(ch)=13;
  for r:=1 to pocet do out:=out+pole[r]; InsText:=out;
 end;


{ *** zadani cisla chovatele a nahrani prisl. dat do pole *** }
function DataLoad:string;
var chc:string;
begin
DataLoad:='';
chc:=InsText(3,54,12);
if ((Length(chc)>0) AND (LoadFile(chc)<>'noexist')) then DataLoad:='OK';
end;


{ *** zobrazovani dat po posuvneho okna *** }
procedure Listing(offset,kurzor:integer);
var n,m,max:integer;
begin
TextColor(0);
if holubu<0 then begin for m:=5 to 21 do begin gotoxy(47,m); writeln('                    '); exit; end; end;
gotoxy(32,2);
TextColor(0);
if holubu>17 then max:=17 else max:=holubu;
for n:=1 to max do
    begin
      TextBackground(19);
      if n=kurzor then TextBackground(2);
      gotoxy(47,n+4); write('                    ');
      gotoxy(47,n+4); write(data[offset+n].cislo);
      TextBackground(0);
    end;
TextBackground(19);
if holubu<17 then for m:=holubu+1 to 17 do begin gotoxy(47,m+4); writeln('                    '); end;
end;


{ *** vlozeni noveho holuba *** }
procedure InsertData;
var chc:string;
    i:integer;
begin
TextColor(0); TextBackground(7);
chc:=InsText(20,5,15);
gotoxy(6,15); writeln('                    ');
if Length(chc)<1 then exit;
if Length(chc)<20 then for i:=Length(chc) to 20 do chc:=chc+' ';
holubu:=holubu+1;
data[holubu].cislo:=chc;
data[holubu].cip:='FFFFFFFF00000000000000000000000';
end;


{ *** vymazani holuba *** }
procedure DeleteData(del:integer);
var i,k:integer;
begin
k:=0;
for i:=1 to holubu do
if i<>del then begin k:=k+1; data[k]:=data[i]; end;
holubu:=holubu-1;
TextBackground(19);
for k:=5 to 21 do begin gotoxy(47,k); writeln('                    '); end;
end;


{ *** editace existujiciho holuba, kod cipu je zachovan *** }
procedure EditData(epos:integer);
var chc:string;
    i:integer;
begin
TextColor(0); TextBackground(7);
chc:=InsText(20,5,15);
gotoxy(6,15); writeln('                    ');
if Length(chc)<1 then exit;
if Length(chc)<20 then for i:=Length(chc) to 20 do chc:=chc+' ';
data[epos].cislo:=chc;
end;


{ *** smycka na editaci pole *** }
procedure DbLoop;
var rpt,oo,xx,m:integer;
begin
gotoxy(1,1);Writeln('Chovatel: '+Copy(head[2],12,20));
oo:=0; xx:=1;
Frame(45,4,68,22,0,7);
Frame(46,5,67,21,7,7);
repeat
 Listing(oo,xx);
 k:=ReadKey;
 rpt:=1;
 if ord(k)=82 then begin InsertData; rpt:=600; end;
 if ord(k)=83 then begin DeleteData(oo+xx); xx:=1; oo:=0; end;
 if ord(k)=60 then EditData(oo+xx);
 if ord(k)=80 then xx:=xx+1;
 if ord(k)=72 then xx:=xx-1;
 if (ord(k)=73) OR (ord(k)=81) then rpt:=10;
 repeat
 if ord(k)=81 then xx:=xx+1;
 if ord(k)=73 then xx:=xx-1;
 if ord(k)=82 then xx:=xx+1;
 if ((xx>holubu) OR ((oo+xx)>holubu)) then xx:=xx-1;
 if xx>17 then begin xx:=17; oo:=oo+1; end;
 if ((xx<1) AND (oo>0)) then oo:=oo-1;
 if xx<1 then xx:=1;
 rpt:=rpt-1;
 until rpt=1;
until ord(k)=27;
WriteIt(soubor);
end;


{ *** START *** }
begin
ClrScr;
repeat
DumpScreen;
gotoxy(70,1); write('           ');
if Dataload<>'OK' then begin
         gotoxy(44,15); TextBackground(3);
         write('Tento chovatel neexistuje'); Delay(1500);
         gotoxy(42,15); TextBackground(2);
         write('Stiskni ENTER pro nove zadani');
         TextBackground(7); k:=ReadKey;
         end
         else DbLoop;
until ord(k)=27;
Textbackground(0);
TextColor(7);
clrscr;
end.